Option Explicit On 
Option Strict On

Imports System
Imports System.IO
Imports System.Windows.Forms
Imports System.Runtime.Serialization.Formatters.Binary

Public Module modMain
    Private m_persUser As CPerson
    Private m_strDataFileName As String = _
      Application.StartupPath & "\settings.dat"

    Public Sub Main()
        Restore()
        Console.WriteLine("Tool zum ndern der " & _
          "Benutzerinformationen")
        Console.WriteLine("Person mit Namen ""{0}""" & _
          " ist aktiv.", m_persUser.Name)
        Console.Write("Geben Sie den neuen Namen ein: ")
        m_persUser.Name = Console.ReadLine()
        Console.WriteLine("Person hat nun den Namen " & _
          """{0}"".", m_persUser.Name)
        Save()
        Console.WriteLine("Person gespeichert, " & _
          " Enter beendet das Programm.")
        Console.ReadLine()
    End Sub

    Private Sub Save()
        Dim fs As New FileStream(m_strDataFileName, _
          FileMode.OpenOrCreate)
        Dim bf As New _
          BinaryFormatter()
        bf.Serialize(fs, m_persUser)
        fs.Close()
    End Sub

    Private Sub Restore()

        ' Hier kann ein Fehler auftreten, wenn die 
        ' Datei nicht existiert oder wenn die Datei
        ' sich nicht deserialisieren lsst. Das Prfen,
        ' ob die Datei existiert, ersparen wir
        ' uns hier, der Code dazu wre "If 
        ' File.Exists(m_strDataFileName) Then...".
        Try
            Dim fs As New FileStream(m_strDataFileName, _
              FileMode.Open)
            Dim bf As New BinaryFormatter()
            m_persUser = CType(bf.Deserialize(fs), CPerson)
            fs.Close()

            ' Die Datei existiert nicht oder es ist 
            ' ein Fehler bei der Deserialisierung 
            ' aufgetreten, daher wird ein Objekt mit
            ' den Standardeinstellungen angelegt.
        Catch

            m_persUser = New CPerson()
        End Try
    End Sub

    <Serializable()> _
    Private Class CPerson
        Public Name As String
        Public Age As Integer
        Public Married As Boolean
        Public Knowledge As Knowledge
    End Class

    <Serializable()> _
    Private Structure Knowledge
        Public VB As Boolean
        Public CSharp As Boolean
    End Structure
End Module